/******************************************************************************************/
/******************************************************************************************/
/*                                                                                                                                                                                */
/* Trigger: DTULTATU_CONSUMIDOR                                                                                                                          */
/* Tabela : CONSUMIDOR                                                                                                                                            */
/*                                                                                                                                                                                */
/* Criao:                                                                                                                                                                  */
/* 28/09/2005 - Wanderson Aloisio                                                                                                                          */
/*                                                                                                                                                                                */
/******************************************************************************************/

IF EXISTS(SELECT * FROM sysobjects O, sysusers U
          WHERE
            o.name = 'DTULTATU_CONSUMIDOR'  and
            type = 'TR' and
            u.uid = o.uid and
            u.name = USER)
   DROP TRIGGER DTULTATU_CONSUMIDOR
GO

CREATE TRIGGER DTULTATU_CONSUMIDOR
ON CONSUMIDOR
FOR INSERT, UPDATE, DELETE
AS
BEGIN
   IF (0 = (SELECT COUNT(*) FROM INSERTED)) BEGIN
      INSERT INTO DELETECACHE (NMTABLECACHE, CDFILICACHE, DSKEYCACHE, DTULTATUCACH)
			      (SELECT 'CONSUMIDOR', '', 'CDCLIENTE='+CDCLIENTE+';CDCONSUMIDOR='+CDCONSUMIDOR+';', GETDATE() FROM DELETED)
   END ELSE BEGIN
      UPDATE CONSUMIDOR
      SET DTULTATUCSUM = GETDATE()
      FROM INSERTED
      WHERE (ISNULL(CONSUMIDOR.CDCLIENTE   ,0) = ISNULL(INSERTED.CDCLIENTE   ,0)) AND
            (ISNULL(CONSUMIDOR.CDCONSUMIDOR,0) = ISNULL(INSERTED.CDCONSUMIDOR,0));
   END;
END;
GO

UPDATE CONSUMIDOR SET DTULTATUCSUM = GETDATE() WHERE DTULTATUCSUM IS NULL
GO

IF EXISTS(SELECT * FROM sysobjects O
          WHERE
            o.name = 'DEFAULT_DTULTATUCSUM' and
            type = 'D')
   ALTER TABLE CONSUMIDOR DROP CONSTRAINT DEFAULT_DTULTATUCSUM
GO

ALTER TABLE CONSUMIDOR ADD CONSTRAINT DEFAULT_DTULTATUCSUM
DEFAULT GETDATE()
FOR DTULTATUCSUM
GO

-- VERSAO --
EXEC ATUVEROBJ 'DTULTATU_CONSUMIDOR','4.10.080';
GO

